//Font sizes to be displayed
myPointSize = [18, 6, 8, 10, 14, 18, 24, 42]; 
var myBounds = [ "6p", "3p", "48p", "63p" ]; //Textbox size --fits 8.5x11 page size in landscape mode 
// Text to be displayed 
var myText = "The quick brown fox jumps over the lazy dog." + "\n" + "1234567890"; 
//List of fonts you want to exclude 
var myExcludeFonts = new Array;
myExcludeFonts = ["Apple Symbols Regular", "Geeza Pro Regular", "Geeza Pro Bold", "Webdings Regular", "Adobe Wood Type Ornaments Std Regular", "Ryo Display Std M", "Ryo Display Std SB", "Ryo Display Std B", "Ryo Display Std EB", "Ryo Display Std H", "Ryo Text Std EL", "Ryo Text Std L", "Ryo Text Std R", "Ryo Text Std M", "GB18030Bitmap regular"];

//Select font (or Would you like to select all fonts?) 
var myFontList = new Array; myFontList.push("All fonts"); 
for(var myCounter2 = 0; myCounter2 < app.fonts.length; myCounter2 ++){
   myFontList.push(app.fonts[myCounter2].name);
}
var myFontDialog = app.dialogs.add({name:"Select Font..."}); with(myFontDialog){
   with(dialogColumns.add()){
      with(dialogRows.add()){
         staticTexts.add({staticLabel:""});
         var myFontDropdown = dropdowns.add({stringList:myFontList, selectedIndex:0});
      }
   }
}
var myFontResult = myFontDialog.show();
if(myFontResult == true) {
   var myFontSelection = myFontList[myFontDropdown.selectedIndex];
   myFontDialog.destroy();
   //Create font book using all or selected font
   if(myFontSelection == "All fonts") {
      var myFonts = new Array;
      myFonts = app.fonts;
   }
   else {
      var myFonts = new Array;
      myFonts[0] = app.fonts.item(myFontSelection);
   }
   //Create a new document
   var myDocument = app.documents.add();
   myDocument.documentPreferences.facingPages = false;
   myDocument.documentPreferences.pageOrientation = PageOrientation.landscape;

   //Loop over all or selected font(s)
   var myPageCounter = 0; //Initialize page counter
   for (myCounter = 0; myCounter < myFonts.length; myCounter++) {
      //If user didn't select a specific font check exclusion list
      var exclFlag = 0; //Initialize
      if (myFonts.length > 1) {
         myFontName = myFonts[myCounter].name.toUpperCase();
         for (myCounter3 = 0; myCounter3 < myExcludeFonts.length; myCounter3++) {
            myExcludeFontName = myExcludeFonts[myCounter3].toUpperCase();
            if (myFontName.replace(/\s/g, "") == myExcludeFontName.replace(/\s/g, "")) {
               exclFlag = 1;
               break;
            }
         }
      }
      //If font is not on exclusion list
      if (exclFlag == 0) {
         //If it's the first page/font don't add a new page
         if (myCounter > 0) {
            myDocument.pages.add();
            myPageCounter++;
         }
         //Set the document's ruler origin to page origin
         myDocument.viewPreferences.rulerOrigin = RulerOrigin.pageOrigin;

         //Create a new text frame
         var myTextFrame = myDocument.pages.item(myPageCounter).textFrames.add();
         //Specify the size and shape of the text frame
         myTextFrame.geometricBounds = myBounds;
         //Create text contents with font name and text
         //Text containing font sizes
         myFontSizeText = " (" + myPointSize[0] + ", " + myPointSize[1] + ", " + myPointSize[2] + ", " + myPointSize[3] + ", " + myPointSize[4] + ", " + myPointSize[5] + ", " + myPointSize[6] + ", " + myPointSize[7] + ")";
         var myTextContents = myFonts[myCounter].name + myFontSizeText + "\n" + "\r" + myText + "\r" + myText + "\r" + myText + "\r" + myText + "\r" + myText + "\r" + myText + "\r" + myText;

         //Place text contents into text frame
         myTextFrame.contents = myTextContents;

         //Format each paragraph
         for (myCounter2 = 0; myCounter2 < myPointSize.length; myCounter2++) {
            myTextFrame.parentStory.paragraphs.item(myCounter2).appliedFont = myFonts[myCounter];
            myTextFrame.parentStory.paragraphs.item(myCounter2).pointSize = myPointSize[myCounter2];
         }
      }
   }
}
else {
   myFontDialog.destroy();
}
